;============================================================
;MAIN CHEAT CODE LAUNCHER (ONCE PROPERLY ADDRESSED IN EXECUTABLE)
;============================================================
;this first part differs from the EXE's interpretation, but because
;the compiler ordered the functions' indexes, there's no point in
;overcomplicating it

;edi=index into DWORD -> usually tested past a certain value by
;the EXE, but it doesn't go that far. The only exception is the "dinos"
;cheat which would crash the game if used in this matter; however, it
;is modified in the initialization.

;note: esi points to potential parameters (NULL if none)

FOUNDVALIDCONSOLEINPUT:
	jmp DWORD [4*edi+CHEATJUMPINDEX]	;cede control to proper cheat
;===========================================================
EXITCHEATCODE:
	pop edi        ;if no cheats or if cheat index overruns index
	pop esi
	pop ebp
	or al,1
	pop ebx        ;don't know how the return value should be
	add esp,3Ch    ;exactly set, but if no cheat is found,
	ret	       ;0 is returned so...
;===========================================================
include 'TESTCHEATCODE.inc'
;===========================================================
DISPLAYOLDLOCCHEAT:	;set/unset LOC cheat variable
	xor [USE_LOC],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYMAPCONSOLE:	;set/unset MAP cheat variable
	xor [USE_MAP],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYCOUNTER:
	xor [USE_COUNTER],1
jmp EXITCHEATCODE
;===========================================================
RESETCOUNTER:
	invoke GetTickCount
	mov [FirstTimeStamp],eax
jmp EXITCHEATCODE
;===========================================================
BIONICWOMAN_MAIN:
	cmp [MXTStateEnabled],0
	    jnz EXITCHEATCODE

	cmp [BIONICWOMAN_enabled],0
	    jz SetSlowSpeed_BIONIC

	mov edx,[GameSpeedVarADDR]
	mov eax,[NormalGameSpeed]
	mov [edx],eax
	mov [BIONICWOMAN_enabled],0
jmp EXITCHEATCODE

SetSlowSpeed_BIONIC:
	mov edx,[GameSpeedVarADDR]
	mov eax,[DefaultSlowSpeed]
	mov [edx],eax
	mov [BIONICWOMAN_enabled],1
jmp EXITCHEATCODE
;===========================================================
DINOS_MAIN:
	mov eax,[DINOS_OBJECT]	;also main "AI System" object
	mov edx,[eax]
	xor BYTE [edx+52h],1	;freeze dinos bool
jmp EXITCHEATCODE
;===========================================================
WOO_MAIN:			;for demo EXE only
	mov eax,[WOO_AMMO_BOOL_ADDR]
	xor BYTE [eax],1
jmp EXITCHEATCODE
;===========================================================
INVUL_EXPERIMENTAL_MAIN_PROC:
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object
	xor BYTE [edx+0DDh],1
ret

INVUL_EXPERIMENTAL_MAIN:
	call INVUL_EXPERIMENTAL_MAIN_PROC
jmp EXITCHEATCODE
;===========================================================
DISPLAYDINOINFO:
	xor [DisplayDinoInfo_BOOL],1
jmp EXITCHEATCODE
;===========================================================
CYCLEDINOINFOLEFT:
	call CYCLEDINOINFOLEFT_PROC
jmp EXITCHEATCODE

CYCLEDINOINFOLEFT_PROC:
	push eax
	mov eax,[DisplayDino_INDEX]
	test eax,eax
	     jz Leftwrap1
	sub eax,sizeof.canimal_info
	mov [DisplayDino_INDEX],eax
	pop eax
	ret

	Leftwrap1:
	mov eax,[CAnimalBufferSize]
	test eax,eax
	     jz NoCycle_CAnimal_Info_Left
	sub eax,sizeof.canimal_info
	mov [DisplayDino_INDEX],eax
	NoCycle_CAnimal_Info_Left:
	pop eax
	ret
;===========================================================
CYCLEDINOINFORIGHT:
	call CYCLEDINOINFORIGHT_PROC
jmp EXITCHEATCODE

CYCLEDINOINFORIGHT_PROC:
	push eax
	mov eax,[DisplayDino_INDEX]
	add eax,sizeof.canimal_info
	cmp eax,[CAnimalBufferSize]
	    jnb Rightwrap1
	mov [DisplayDino_INDEX],eax
	pop eax
	ret

	Rightwrap1:
	mov [DisplayDino_INDEX],0
	pop eax
	ret
;===========================================================
KILLACTIVEDINO:
	mov ecx,[DisplayDino_INDEX]
	mov eax,[CAnimalBuffer]
	test eax,eax
	     jz EXITCHEATCODE
	mov ebx,[eax+ecx]		;ebx=CAnimal instance
	mov DWORD [ebx+50h],0
jmp EXITCHEATCODE
;===========================================================
KILLALLDINOS:
	mov edx,[CAnimalBuffer]
	test edx,edx
	     jz EXITCHEATCODE

	KillAll_Loop_3243:
	mov eax,[edx+canimal_info.Instance]
	mov DWORD [eax+50h],0		;current dino health (set to 0)
	add edx,sizeof.canimal_info
	cmp edx,[CAnimalBufferEnd]
	    jb KillAll_Loop_3243

jmp EXITCHEATCODE
;===========================================================
SHOWDINOSONMAP:
	xor [ShowDinosOnMap_BOOL],1
jmp EXITCHEATCODE
;===========================================================
SHOWACTIVEDINOONMAP:
	xor [ShowActiveDinoOnMap_BOOL],1
jmp EXITCHEATCODE
;===========================================================
HEALACTIVEDINO:
	mov eax,[CAnimalBuffer]
	test eax,eax
	mov esi,[DisplayDino_INDEX]
	     jz EXITCHEATCODE
	mov ebx,[eax+esi+canimal_info.Instance]      ;ebx=CAnimal instance

	mov ebp,esp
	sub esp,50

	mov ecx,ebx
	lea eax,[ebp-50]
	mov edx,[ecx]
	push eax
	call DWORD [edx+10h]	;get current location/orientation info

	mov ecx,[CAnimalBuffer]
	lea edx,[esi+ecx+canimal_info.InitialData.Wquat]   ;edx=dino's initial info (quat)

	mov eax,[edx]		;set 4 original orientation values for dino
	mov [ebp-50+12],eax	;(to ensure he is able to get up properly if he was killed)
	mov eax,[edx+4]
	mov [ebp-50+16],eax
	mov eax,[edx+8]
	mov [ebp-50+20],eax
	mov eax,[edx+12]
	mov [ebp-50+24],eax

	mov edx,[ebx]
	lea eax,[ebp-50]
	push 0
	push eax
	mov ecx,ebx
	call DWORD [edx+38h]	;set new orientation values

	mov eax,[ebx+54h]		;get MaxHitPoints
	mov [ebx+50h],eax		;Set MaxHitPoints as new HitPoints

	mov esp,ebp
jmp EXITCHEATCODE
;===========================================================
CHANGEPLAYERTYPE_PROC:	;switches player class AITypes
			;BYTE [esp+4] = new AIType (-1 for switch from 0-5/5-0)
push edi
push edx
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edi,[eax]		;edi = main "Player" class

	mov eax,[edi+0ACh]	;eax=first sub-class leading to AIType
	mov ecx,[eax+28h]	;ecx=2nd...
	mov edx,[ecx+10h]	;edx= AIType sub-class

	mov al,[esp+12]
	    cmp al,0FFh
		jnz AITypeSetTo_NULL_1
	mov al,[edx+8h] 	;al = AIType value
	    sub al,5
		jz AITypeSetTo_NULL_1
	    mov al,5
	    AITypeSetTo_NULL_1:
	mov [edx+8h],al

	mov eax,[edi+0B0h]	;eax=first sub-class leading to AIType2
	mov ecx,[eax+28h]	;ecx=2nd...
	mov edx,[ecx+10h]	;edx= AIType2 sub-class

	mov al,[esp+12]
	    cmp al,0FFh
		jnz AITypeSetTo_NULL_2
	mov al,[edx+8h] 	;al = AIType2 value
	    sub al,5
		jz AITypeSetTo_NULL_2
	    mov al,5
	    AITypeSetTo_NULL_2:
	mov [edx+8h],al

	;note: there is a third first sub-class, but it points to the same
	;      sub-classes as the second first sub-class
pop edx
pop edi
ret 4

CHANGEPLAYERTYPE:
	push -1
	call CHANGEPLAYERTYPE_PROC
jmp EXITCHEATCODE
;===========================================================
SHOWPLAYERFACEFLOATS:
	xor [ShowFaceFloats_BOOL],1
jmp EXITCHEATCODE
;===========================================================
ENABLEFLYCHEAT:
	cmp [THIRDP_enabled],1
	    jz EXITCHEATCODE
	cmp [FD_enabled],1
	    jz EXITCHEATCODE

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object

	mov eax,[edx+30h]
	mov [LastXPostion_FLY],eax
	mov eax,[edx+34h]
	mov [LastYPostion_FLY],eax
	mov eax,[edx+38h]
	mov [LastZPostion_FLY],eax

	test [FLY_MODE_BOOL],1
	    jz Disable_Keys_345345
	and [FLY_MODE_BOOL],0
	and BYTE [edx+0DDh],0FEh	;INVUL
	push 5
	call CHANGEPLAYERTYPE_PROC
	call EnableInGameKeys
jmp EXITCHEATCODE

Disable_Keys_345345:
	or BYTE [edx+0DDh],1		;INVUL
	push 0
	call CHANGEPLAYERTYPE_PROC
	call DisableInGameKeys
	invoke GetTickCount
	mov [Key_Last_Recorded_Time],eax
	or [FLY_MODE_BOOL],1
jmp EXITCHEATCODE
;===========================================================
TELEPORTDINOCHEAT:
	test esi,esi
	mov ebx,[CAnimalBuffer]
	    jz EXITCHEATCODE
	test ebx,ebx
	mov edi,[DisplayDino_INDEX]
	     jz EXITCHEATCODE

	mov ebp,esp
	sub esp,32	;32 for buffer

	mov ecx,[ebx+edi+canimal_info.Instance]

	mov edx,[ecx]
	mov ebx,ecx
	push esp
	call DWORD [edx+10h]	;get current position/flags/values/whatever

	lea eax,[ebp-32]
	lea ecx,[ebp-28]
	lea edx,[eax+8]
invoke sscanf,esi,FLOAT_RETRIEVE_STRING,eax,ecx,edx

	mov edx,[ebx]
	lea eax,[ebp-32]
	push 0
	push eax
	mov ecx,ebx
	call DWORD [edx+38h]	;set new orientation values

	mov esp,ebp		;stack adjust

jmp EXITCHEATCODE
;===========================================================
SHOWPLAYERHEALTH:
	xor [ShowPlayerHealth_BOOL],1
jmp EXITCHEATCODE
;===========================================================
TOGGLEFPSDISPLAY:
	xor [FPS_toggle],1
	mov [FPS_framecount],0
jmp EXITCHEATCODE
;===========================================================
VIDEOCAPTURETOGGLE:
	jmp Do_Video_Record_Toggle_Main
;===========================================================
SETHIGHHPVALUE:
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edi,[eax]
;Player HitPoints
	mov DWORD [edi+50h],SUPER_HP_VALUE
;Player MaxHitPoints
	mov DWORD [edi+54h],SUPER_HP_VALUE
jmp EXITCHEATCODE
;===========================================================
SETNORMALHPVALUE:
	mov edx,[GameDifficultyValue]
	cmp edx,5
	    jb GameDifficultyValueValid_HPSET
	    mov edx,2
	GameDifficultyValueValid_HPSET:
	shl edx,2			 ;*4

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edi,[eax]
;Player HitPoints
	fld DWORD [float_100]
	fmul DWORD [GAME_DIFFICULTY_TABLE+20+edx]
	fstp DWORD [edi+50h]
;Player MaxHitPoints
	fld DWORD [float_100]
	fmul DWORD [GAME_DIFFICULTY_TABLE+20+edx]
	fstp DWORD [edi+54h]
jmp EXITCHEATCODE
;===========================================================
SHOWTEMPDRAWDIST_CHEAT:
	invoke GetTickCount
	mov [DrawDistDisplayTime],eax
jmp EXITCHEATCODE
;===========================================================
TOGGLEDRVOBJPOSDISPLAY:
	mov eax,[ATXDRV_CURROBJ]
	test eax,eax
	     jz EXITCHEATCODE
	mov edx,[eax+atxdrv_base.Instance]
	mov esi,1
	call OBJCHEATTOGGLE_PROC
jmp EXITCHEATCODE
;===========================================================
DOLEVELLOADCHEAT:
	test esi,esi
	     jz NO_DOLEVELLOADCHEAT_A
	FINDSTRINGSTART esi
	mov edx,esi
	FINDSTRINGEND edx
	sub edx,esi
	cmp edx,5
	mov ecx,AT16_SIM_OBJECT
	    jb NO_DOLEVELLOADCHEAT_A
	mov [ecx+0Ch],DWORD 00000010h
	mov [ecx+04h],DWORD 0
	mov [ecx+08h],edx
	mov eax,[ecx]
	mov [ecx+20h],esi
	call DWORD [eax+08h]
jmp EXITCHEATCODE

NO_DOLEVELLOADCHEAT_A:
	mov [TempMessageString],LevelLoad_INVALID_STR
	invoke GetTickCount
	mov [TempMessageTime],eax
jmp EXITCHEATCODE
;===========================================================
TOGGLEBUFSIZEDISPLAY:
	xor [UseBUFSIZEInfo],1
jmp EXITCHEATCODE
;===========================================================
OBJCHEATTOGGLE_PROC:	   ;esi points to object address string
			   ;if esi is null (or if instance invalid), turns off OBJ cheat
			   ;if edx is not null, value in edx is used instead of esi string
push ebx
	test esi,esi
	     jz DisableUseObjCheat
	test edx,edx
	mov [ObjCheatCurrentObject],edx
	     jnz NoObjCheatStringScan
	invoke sscanf,esi,ObjCheat_HEX_STR,ObjCheatCurrentObject
	add esp,12
	NoObjCheatStringScan:
	mov ebx,[ObjCheatCurrentObject]
	test ebx,ebx
	     jz DisableUseObjCheat_ErrorMsg
	invoke IsBadReadPtr,ebx,050h	       ;base object class (variable size, at least 050h for position/orientation values)
	test eax,eax
	     jnz DisableUseObjCheat_ErrorMsg
	mov ebx,[ebx+28h]
	invoke IsBadReadPtr,ebx,8	       ;first sub-object
	test eax,eax
	     jnz DisableUseObjCheat_ErrorMsg
	mov ebx,[ebx+0Ch]
	invoke IsBadReadPtr,ebx,8	       ;second sub-object (main)
	test eax,eax
	     jnz DisableUseObjCheat_ErrorMsg
	mov eax,[ObjCheatCurrentObject]
	mov ebx,[eax]
	invoke IsBadReadPtr,ebx,8	       ;object VTable
	test eax,eax
	     jnz DisableUseObjCheat_ErrorMsg

	mov [ObjCheatClassTypeStr],ObjOutput_Err_2_STR	;set initial class type (none)
	sub ebx,4
	invoke IsBadReadPtr,ebx,8	       ;address of object VTable member [-4h] (debug info pointer(?))
	test eax,eax
	     jnz ObjCheatNoClassType
	mov ebx,[ebx]
	invoke IsBadReadPtr,ebx,14h	       ;object VTable member [-4h] itself (debug info pointer(?))
	test eax,eax
	     jnz ObjCheatNoClassType
	mov ebx,[ebx+0Ch]
	invoke IsBadReadPtr,ebx,8	       ;debug info member [+0Ch]
	test eax,eax
	     jnz ObjCheatNoClassType
	add ebx,8
	invoke IsBadStringPtr,ebx,256	       ;Class type string
	test eax,eax
	     jnz ObjCheatNoClassType
	mov [ObjCheatClassTypeStr],ebx
	ObjCheatNoClassType:
	mov eax,[ObjCheatCurrentObject]
	mov [UseObjCheat],1
	mov [OBJN_instance],eax
pop ebx
ret

DisableUseObjCheat_ErrorMsg:
	SHOWTEMPMESSAGE ObjOutput_Err_STR
pop ebx
ret

DisableUseObjCheat:
	mov [UseObjCheat],0
pop ebx
ret

OBJCHEATTOGGLE:
	xor edx,edx
	call OBJCHEATTOGGLE_PROC
jmp EXITCHEATCODE
;===========================================================
FOLLOWDINOCHEATTOGGLE_PROC:	;[esp+4] = FD_fetch function
				;Will only toggle FOLLOWDINO state off
				;if FD_fetch function is same as before
				;This is so that the same feature that last used FOLLOWDINO
				;must be re-used to disable it before another feature uses it.

	cmp [THIRDP_enabled],1
	    jz NOFOLLOWDINOCHEATSET
	cmp [FLY_MODE_BOOL],1
	    jz NOFOLLOWDINOCHEATSET

	cmp [FD_enabled],TRUE
	    jz FOLLOWDINOCHEATDISABLE_SECTION

	mov edx,[LocationADDR]
	mov edx,[edx]
	xor eax,eax
	mov edx,[edx+14h]

	mov ecx,[edx+50h]
	mov [edx+50h],eax
	mov [FD_prevcamobj1],ecx

	mov ecx,[edx+54h]
	mov [edx+54h],eax
	mov [FD_prevcamobj2],ecx

	call DisableInGameKeys
	mov [DisableInGameMouseMvt],TRUE

	invoke GetTickCount
	mov edx,[esp+4]
	mov [FD_tickcountinput],eax
	mov [FD_tickcountcammvt],eax
	mov [FD_fetchfunction],edx
	mov [FD_enabled],TRUE

ret 4

FOLLOWDINOCHEATDISABLE_SECTION:
	mov eax,[esp+4]
	cmp eax,[FD_fetchfunction]	   ;must have same function to disable!
	    jnz NOFOLLOWDINOCHEATSET

	mov edx,[LocationADDR]
	mov [FD_enabled],0
	mov edx,[edx]
	mov eax,[FD_prevcamobj1]
	mov edx,[edx+14h]
	mov ecx,[FD_prevcamobj2]
	mov [edx+50h],eax		;replace original camera object
	mov [edx+54h],ecx

	mov [DisableInGameMouseMvt],FALSE
	call EnableInGameKeys

NOFOLLOWDINOCHEATSET:
ret 4


FOLLOWDINOCHEATTOGGLE:
	cmp [CAnimalBuffer],0
	    jz EXITCHEATCODE
	stdcall FOLLOWDINOCHEATTOGGLE_PROC,FD_FetchCAnimalInstance
jmp EXITCHEATCODE
;===========================================================
TOGGLETHIRDPCHEAT:
	cmp [FD_enabled],1
	    jz EXITCHEATCODE
	cmp [FLY_MODE_BOOL],1
	    jz EXITCHEATCODE

	cmp [THIRDP_enabled],1
	    jz DisableTHIRDPCHEAT

	mov edx,[LocationADDR]
	mov edx,[edx]
	xor eax,eax
	mov edx,[edx+14h]

	mov ecx,[edx+50h]
	mov [edx+50h],eax
	mov [THIRDP_prevcamobj1],ecx

	mov ecx,[edx+54h]
	mov [edx+54h],eax
	mov [THIRDP_prevcamobj2],ecx

	invoke GetTickCount
	mov [THIRDP_camtick],eax
	mov [THIRDP_inputtick],eax
	mov [THIRDP_enabled],1
jmp EXITCHEATCODE

DisableTHIRDPCHEAT:
	mov edx,[LocationADDR]
	mov [THIRDP_enabled],0
	mov edx,[edx]
	mov eax,[THIRDP_prevcamobj1]
	mov edx,[edx+14h]
	mov ecx,[THIRDP_prevcamobj2]
	mov [edx+50h],eax		;replace original camera object
	mov [edx+54h],ecx
jmp EXITCHEATCODE
;===========================================================
TOGGLETHIRDPAIMCHEAT:
	xor [THIRDPAIM_enabled],1
jmp EXITCHEATCODE
;===========================================================
OBJNCHEATTOGGLE:
	test esi,esi
	mov eax,esi
	    jz OBJNCHEATTOGGLEOFF
	call GetInstanceFromStringGlobal
	test eax,eax
	mov edx,eax
	    jz OBJNCHEATTOGGLEINVALIDINST
	mov esi,1
	call OBJCHEATTOGGLE_PROC	     ;edx = instance, esi = non-zero
jmp EXITCHEATCODE

OBJNCHEATTOGGLEOFF:
	mov esi,0
	call OBJCHEATTOGGLE_PROC	     ;esi = zero (turn OBJ display off)
jmp EXITCHEATCODE

OBJNCHEATTOGGLEINVALIDINST:
	SHOWTEMPMESSAGE ObjNOutput_Err_STR
jmp EXITCHEATCODE

;===========================================================
OBJFCHEATTOGGLE:
	cmp [OBJN_instance],0
	    jz EXITCHEATCODE
	stdcall FOLLOWDINOCHEATTOGGLE_PROC,FD_FetchOBJNInstance
jmp EXITCHEATCODE
;===========================================================
SELECTCLOSESTDINO:
	mov esi,[CAnimalBuffer]
	test esi,esi
	     jz EXITCHEATCODE

	mov edi,esi
	mov eax,[esi+canimal_info.Instance]
	call GetCPlayerPrivInstance	  ;ecx = player instance
	sub esp,8
	fld DWORD [eax+30h]
	fsub DWORD [ecx+30h]
	fmul st0,st0
	fld DWORD [eax+34h]
	fsub DWORD [ecx+34h]
	fmul st0,st0
	fld DWORD [eax+38h]
	fsub DWORD [ecx+38h]
	fmul st0,st0
	faddp st1,st0
	faddp st1,st0
	fstp DWORD [esp]	     ;initial distance (of first instace)
	jmp SELECTCLOSESTDINO_LOOP_START

	SELECTCLOSESTDINO_LOOP:
	mov eax,[esi+canimal_info.Instance]
	fld DWORD [eax+30h]
	fsub DWORD [ecx+30h]
	fmul st0,st0
	fld DWORD [eax+34h]
	fsub DWORD [ecx+34h]
	fmul st0,st0
	fld DWORD [eax+38h]
	fsub DWORD [ecx+38h]
	faddp st1,st0
	faddp st1,st0
	fcom DWORD [esp]
	fstsw ax
	fstp DWORD [esp+4]
	test ah,1h
	     jz SELECTCLOSESTDINO_LOOP_START   ;is current distance lower?
	     mov eax,[esp+4]
	     mov edi,esi
	     mov [esp],eax
	SELECTCLOSESTDINO_LOOP_START:
	add esi,sizeof.canimal_info
	cmp esi,[CAnimalBufferEnd]
	    jb SELECTCLOSESTDINO_LOOP

	sub edi,[CAnimalBuffer]
	add esp,8
	mov [DisplayDino_INDEX],edi
jmp EXITCHEATCODE
;===========================================================
TOGGLEGSPDDISPLAY:
	xor [DisplayGSPD_BOOL],1
jmp EXITCHEATCODE
;===========================================================
